# -*- coding: utf-8 -*-
import difflib

from App.class_init import InitializeClass
from Products.CMFDiffTool.BaseDiff import _getValue
from Products.CMFDiffTool.TextDiff import TextDiff


class BinaryDiff(TextDiff):
    """Simple binary difference"""

    meta_type = "Binary Diff"

    def _parseField(self, value, filename=None):
        """Parse a field value in preparation for diffing"""
        if filename is None:
            # Only return a value for the filename
            return ['']
        else:
            return [self.filenameTitle(filename)]

    def testChanges(self, ob):
        """Test the specified object to determine if the change set will apply without errors"""
        value = _getValue(ob, self.field)
        if not self.same and value != self.oldValue:
            raise ValueError, ("Conflict Error during merge", self.field, value, self.oldValue)

    def applyChanges(self, ob):
        """Update the specified object with the difference"""
        # Simplistic update
        self.testChanges(ob)
        if not self.same:
            setattr(ob, self.field, self.newValue)

InitializeClass(BinaryDiff)

